<?php

require_once( "xacmlv3Request.php" );
require_once( "xacmlv3Decision.php" );

function canAccess( $action, $ressource )
{

	$adresse = '127.0.0.1';
	$port=12345;
	// No Timeout 
	set_time_limit(0);
	$socket = socket_create(AF_INET, SOCK_STREAM, 0) or die("Could not create socket\n");
	$peperr = socket_connect($socket, $adresse, $port) or die("Could not connect toserver\n");

	$req = new xacmlRequest();

	$req->startAttributes('urn:oasis:names:tc:xacml:3.0:attribute-category:subject');
	$req->addAttributeIssuedBy('urn:siera:role','http://www.w3.org/2001/XMLSchema#string',$_SESSION['role'],$_SESSION['issuer']);
	$req->endAttributes();

	$req->startAttributes('urn:oasis:names:tc:xacml:3.0:attribute-category:resource');
	$req->addAttribute('urn:oasis:names:tc:xacml:1.0:resource:resource-id','http://www.w3.org/2001/XMLSchema#string', $ressource);

	$nomfichier = "files/step.txt";
        $tabfich=file($nomfichier);
        $step=$tabfich[0];
	
	$req->addAttribute('urn:siera:step','http://www.w3.org/2001/XMLSchema#string', $step);
	$req->endAttributes();

	$req->startAttributes('urn:oasis:names:tc:xacml:3.0:attribute-category:action');
	$req->addAttribute('urn:oasis:names:tc:xacml:1.0:action:action-id','http://www.w3.org/2001/XMLSchema#string',$action);
	$req->endAttributes();

	$req->endRequest();
	//print htmlentities($req->getRequest());
	$message=$req->getRequest();
	socket_write($socket, $message, strlen($message)) or die("Could not send data to server\n");

	$result = socket_read ($socket, 1024) or die("Could not read server response\n");
	//echo "Reply From Server :".$result;
	socket_close($socket);

	$decision = new xacmlResponse($result);
	//echo "Decision :".$decision->getDecision();
	switch($decision->getDecision())
        {
                case "Permit":
                        return true;
                case "Deny":
                        return false;
                case "NotApplicable":
                        return false;
        }

}

?>
